(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('@nowzoo/ngx-bootstrap-modal', ['exports', 'rxjs', 'rxjs/operators', '@angular/core'], factory) :
    (factory((global.nowzoo = global.nowzoo || {}, global.nowzoo['ngx-bootstrap-modal'] = {}),global.rxjs,global.rxjs.operators,global.ng.core));
}(this, (function (exports,rxjs,operators,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxBootstrapModalService = /** @class */ (function () {
        function NgxBootstrapModalService(_appRef, _zone) {
            this._appRef = _appRef;
            this._zone = _zone;
        }
        Object.defineProperty(NgxBootstrapModalService.prototype, "appRef", {
            get: /**
             * @return {?}
             */ function () {
                return this._appRef;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapModalService.prototype, "zone", {
            get: /**
             * @return {?}
             */ function () {
                return this._zone;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} templateRef
         * @return {?}
         */
        NgxBootstrapModalService.prototype.show = /**
         * @param {?} templateRef
         * @return {?}
         */
            function (templateRef) {
                var _this = this;
                /** @type {?} */
                var events$ = new rxjs.Subject();
                /** @type {?} */
                var instance = {
                    shown: new Promise(( /**
                     * @param {?} resolve
                     * @return {?}
                     */function (resolve) {
                        events$
                            .pipe(operators.filter(( /**
                     * @param {?} e
                     * @return {?}
                     */function (e) { return 'shown' === e.type; })))
                            .pipe(operators.take(1))
                            .subscribe(( /**
                     * @return {?}
                     */function () {
                            _this.zone.run(resolve);
                        }));
                    })),
                    hidden: new Promise(( /**
                     * @param {?} resolve
                     * @return {?}
                     */function (resolve) {
                        events$
                            .pipe(operators.filter(( /**
                     * @param {?} e
                     * @return {?}
                     */function (e) { return 'hidden' === e.type; })))
                            .pipe(operators.take(1))
                            .subscribe(( /**
                     * @return {?}
                     */function () { return resolve(); }));
                    })),
                    events: events$.asObservable(),
                    hide: null,
                    handleUpdate: null,
                    modalEl: null
                };
                /** @type {?} */
                var viewRef = templateRef.createEmbeddedView({ instance: instance });
                this.appRef.attachView(viewRef);
                /** @type {?} */
                var el = instance.modalEl = viewRef.rootNodes[0];
                document.body.appendChild(el);
                /** @type {?} */
                var $el = jQuery(el);
                $el.modal({ show: false });
                $el.on('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal', ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    _this.zone.run(( /**
                     * @return {?}
                     */function () {
                        events$.next(event);
                    }));
                }));
                instance.hide = ( /**
                 * @return {?}
                 */function () {
                    $el.modal('hide');
                    return instance.hidden;
                });
                instance.handleUpdate = ( /**
                 * @return {?}
                 */function () {
                    $el.modal('handleUpdate');
                });
                instance.hidden.then(( /**
                 * @return {?}
                 */function () {
                    $el.off('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal');
                    $el.modal('dispose');
                    document.body.removeChild(el);
                    _this.appRef.detachView(viewRef);
                    viewRef.destroy();
                }));
                $el.modal('show');
                return instance;
            };
        NgxBootstrapModalService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxBootstrapModalService.ctorParameters = function () {
            return [
                { type: i0.ApplicationRef },
                { type: i0.NgZone }
            ];
        };
        /** @nocollapse */ NgxBootstrapModalService.ngInjectableDef = i0.defineInjectable({ factory: function NgxBootstrapModalService_Factory() { return new NgxBootstrapModalService(i0.inject(i0.ApplicationRef), i0.inject(i0.NgZone)); }, token: NgxBootstrapModalService, providedIn: "root" });
        return NgxBootstrapModalService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxBootstrapModalModule = /** @class */ (function () {
        function NgxBootstrapModalModule() {
        }
        NgxBootstrapModalModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [NgxBootstrapModalService]
                    },] }
        ];
        return NgxBootstrapModalModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgxBootstrapModalService = NgxBootstrapModalService;
    exports.NgxBootstrapModalModule = NgxBootstrapModalModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=nowzoo-ngx-bootstrap-modal.umd.js.map